#!/usr/local/bin/ruby
# (c) 2004 Andreas Krennmair
# $Id: edit.cgi,v 1.4 2004/03/27 18:11:31 ak Exp $

require 'cgi'
require 'cgi/session'
require 'html/template'
require 'entries.rb'
require 'auth.rb'
require 'config.rb'

$cgi = CGI.new


if not is_authenticated? then
  tmpl = HTML::Template.new("tmpl/autherr.html")
  $cgi.out { tmpl.output }
  Kernel.exit(0)
end

tmpl = HTML::Template.new("tmpl/edit.html")

action = $cgi['action']

if action == 'add' then
  subject = $cgi['subject']
  body = $cgi['body']
  time = $cgi['time']
  wiki_name = EntryManager.wiki_name(subject)
  entry = Entry.new("entries/" + time + wiki_name + ".txt")
  entry.set_subject(subject)
  entry.set_body(body)
  entry.set_categories([0]) # TODO
  entry.write
  tmpl.param({ 'action' => 'add' })
elsif action == 'edit' then
  e = Entry.new($cgi['filename'])
  tmpl.param({ 'action' => 'save', 'subject' => e.get_subject.chomp, 'filename' => $cgi['filename'], 'body' => e.get_body, 'time' => e.get_time })
elsif action == 'save' then
  e = Entry.new($cgi['filename'])
  e.set_subject($cgi['subject'])
  e.set_body($cgi['body'])
  e.set_categories([0])
  e.write
  tmpl.param({ 'action' => 'add' })
elsif action == 'delete' then
  File.unlink($cgi['filename'])
  $cgi.out('status' => 'REDIRECT','location' => 'edit.cgi') { "" }
  Kernel.exit(0) # don'l let Ruby execute all the other code
else
  tmpl.param({ 'action' => 'add' }) # default action
end

em = EntryManager.new("entries")

curtime = Time.now.strftime("%Y%m%d-%H%M%S-")
tmpl.param({ 'title' => $conf['blogtitle'], 'time' => curtime })

entries = em.get_entries[0..$conf['lastposts']-1]

entries.each do |e|
  tmpl.node("entries").param({ 'subject' => e.get_subject, 'body' => e.get_body, 'entry' => e.get_filename, 'time' => e.get_time })
end

$cgi.out { tmpl.output }
