# (c) 2004 Andreas Krennmair
# $Id: entries.rb,v 1.3 2004/03/27 17:41:42 ak Exp $

class Entry

  def initialize(file)
    begin
      entry_file = File.new(file)
      i = 0
      line0 = nil
      lines = []
      entry_file.each_line do |line|
        if i == 0 then
          line0 = line
        else
          lines << line
        end
        i += 1
      end
      fields = line0.split(/ /)
      @categories = fields[0].split(/,/)
      fields.shift
      line0 = fields.join(" ")
      @subject = line0
      @body = lines.join("")
    rescue
    end
    @filename = file
  end

  def get_subject
    @subject
  end

  def get_body
    @body
  end

  def set_subject(s)
    @subject = s
  end

  def set_body(b)
    @body = b
  end

  def get_filename
    @filename
  end

  def get_time
    x = @filename.split("/")
    fn = x[x.size-1]
    year = fn[0..3]
    month = fn[4..5]
    day = fn[6..7]
    hour = fn[9..10]
    min = fn[11..12]
    sec = fn[13..14]
    return "#{year}-#{month}-#{day} #{hour}:#{min}:#{sec}"
  end

  def set_filename(f)
    @filename = f
  end

  def get_categories
    @categories
  end

  def set_categories(a)
    @categories = a
  end

  def write
    begin
      f = File.new(@filename,"w+")
      line0 = @categories.join(",") + " " + @subject + "\n"
      f.write(line0)
      @body.each do |line|
        f.write(line)
      end
      f.close
    rescue
      $stderr.puts "Entry#write: unable to write to #{@filename}: #{$!}"
    end
  end

end

class EntryManager
  
  def initialize(path)
    @path = path
    @filenames = []
    @entries = []
    begin
      Dir.new(@path).each do |file|
        if file =~ /^[0-9]{8}-[0-9]{6}-/ then
          @filenames << file
        end
      end
    rescue
      $stderr.puts "EntryManager#initialize: unable to open #{@path}"
    end
    @filenames = @filenames.sort.reverse
    @filenames.each do |f|
      @entries << Entry.new(@path + "/" + f)
    end
  end

  def get_filenames
    @filenames
  end

  def get_entries
    @entries
  end

  def get_matching(pattern)
    x = []
    @filenames.each_index do |i|
      if @filenames[i] =~ pattern then
        x << @entries[i]
      end
    end
    x
  end

  def EntryManager.wiki_name(x)
    x.gsub!(/[^ a-zA-Z]/,"");
    foo = x.split(" ")
    foo.each_index do |i|
      foo[i][0..0] = foo[i][0..0].capitalize
    end
    return foo.join("")
  end

end
