#!/usr/local/bin/ruby
# (c) 2004 Andreas Krennmair
# $Id: index.cgi,v 1.4 2004/03/27 17:41:43 ak Exp $

require 'cgi'
require 'html/template'
require 'categories.rb'
require 'linklist.rb'
require 'entries.rb'
require 'config.rb'

$cgi = CGI.new
em = EntryManager.new("entries")
cm = CategoryManager.new("conf/categories.txt")

blogroll = LinkListManager.new("conf/blogroll.txt")
links = LinkListManager.new("conf/links.txt")

tmpl = HTML::Template.new("tmpl/blogpage.html")
entries = em.get_entries[0..$conf['lastposts']-1]
entries.each do |e|
  cats = e.get_categories
  cat_names = []
  cats.each do |c|
    cat_names << cm.get_category(c.to_i)
  end
  cat_string = cat_names.join(", ")
  tmpl.node("blogpage").param({ 'subject' => e.get_subject, 'body' => e.get_body, 'time' => e.get_time, 'categories' => cat_string })
end

tmpl.param({ 'blogtitle' => $conf['blogtitle'] })

blogroll.add_node_to_template(tmpl,"blogroll")
links.add_node_to_template(tmpl,"links")

$cgi.out { tmpl.output }
